*==== ==================================================================

* test clustering
* by Andy, 2005-2011, P.D.
      PROGRAM tkm
      
      IMPLICIT NONE      
      INTEGER mlim, M,N,K,ITER,FAULT             ! points, dimension, errors
      INTEGER i, j, klim, kmin, kmax, o, ferr, L, r
      INTEGER iopt                         ! choose an initialization method

      REAL A(178,13), C(3, 13), iswap, Asub(178,13), T(13), y
      REAL u, ucalc, w, total, best, worst, f
      INTEGER Q(178), P(3), ind(178), sample, opt

      LOGICAL fexist, dump, thuro
      CHARACTER*9 fname

      DATA M,N,R,K,ITER,FAULT,total,worst /178,13,3,1,1000, 0, 0., 0./
      DATA mlim, kmin, kmax, klim /178, 3, 3, 3 /

      CALL SRAND(TIME())
      f = 1.0
      y = 3.0
      best = 1E30
      opt =  1 + 2 + 4 + 8 + 32 + 64
      dump = .TRUE.
      thuro = .TRUE.

*        get input file
      fname = 'wine.data'
      INQUIRE (FILE = fname, EXIST = fexist, IOSTAT = ferr, ERR = 901)
      IF (.NOT. fexist) STOP 'File not found'
      IF (ferr .NE. 0) STOP 'Error opening input file'
      OPEN (UNIT = 1, FILE = fname, STATUS = 'OLD', 
     &        ACCESS = 'SEQUENTIAL', ERR=901)

***** ******************************************************************
*       start reading in data
       DO i = 1, M
         READ (UNIT = 1, FMT=*, END = 310) w, ( A(i,j), j = 1, 13)
       END DO
 310  CLOSE (UNIT = 1, ERR=901)
!      PRINT *, A
!      PAUSE

!         disable modulo distance
      DO j = 1, N ; T(j) = 0 ; END DO

!      compare initialization methods 
      iopt = 3

      DO o = 1, 1
      
*---- ------------------------------------------------------------------
*       random cluster centers (good ways to initialize are hard)
      IF (iopt .EQ. 1) THEN
         DO L = 1, K
          C(L, 1) = RAND(0)*2 + 5.
          C(L, 2) = RAND(0)*1.5 + 2.
          C(L, 3) = RAND(0)*2 + 5.
          C(L, 4) = RAND(0)*1.5 + 1.
         END DO

*       random points as centers
       ELSE IF (iopt .EQ. 2) THEN
        DO L = 1, k
        r = INT(RAND(0)*m) + 1
         DO j = 1, n
            C(L,j) = A(r,j) 
         END DO
       END DO
 
!       random cluster memberships
      ELSE IF (iopt .EQ. 3 .OR. iopt .EQ. 5) THEN
       DO L = 1, k ; P(L) = 0 ; END DO
       DO i = 1, m
        Q(i) = INT(RAND(0)*K) + 1
        P(Q(i)) = P(Q(i)) + 1
       END DO

!        hierarchical
      ELSE IF (iopt .EQ. 4) THEN
       CALL hclust(A,mlim,m,n,k,Q,P,T,y,fault)
      END IF

*        let clusters be the average of their points
      IF (iopt .EQ. 3 .OR. IOPT .EQ. 4 .OR. IOPT .EQ. 5) THEN
       DO j = 1, N
        DO L = 1,K
         C(L,j) = 0.0
        END DO
       END DO
       
       DO j = 1, n
        DO i = 1, m
          r = q(i)
          C(r,j) = C(r,j) + A(i,j)
         END DO
        END DO
       
       DO j = 1, n
        DO L = 1, k
         C(L,j) = C(L,j) / P(L)
        END DO
       END DO
      END IF
              
!       multi-stage with subsampling
      sample = m/2

      IF (iopt .EQ. 5) THEN
        DO i = 1, m ; ind(i) = i ; END DO ! make a random permutation vector
        DO i = m, m-sample+1, -1   ! partial Durstenfeld shuffle
          r = INT(RAND(0)*i) + 1   
          iswap = ind(r) ; ind(r) = ind(i) ; ind(i) = iswap
        END DO
*        print *, ind
*        pause
        
        DO j = 1, n                     ! transfer data to temp. array
          DO i = 1, sample     
            Asub(i,j) = A(ind(m-i+1),j)
          END DO
        END DO
        
        CALL kmeans(Asub, m,sample, n, C,kmax,K, Q, P, T, iter, U,fault)
      END IF

*vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
*      everything prior leads up to the next line
*^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
!        PRINT *, 'Calling sub, m=', M, ' n=', n, ' k=', k
!         CALL kmeans(A,M,N,C,kmax,K,Q,P,T,ITER,thuro,u,FAULT)
!         CALL kmedians(A,M,N,C,kmax,K,Q,P,T,iter,thuro,U,fault)
         k = 3 ; r = 1
          CALL kasc(A,M,N,R,C,klim,kmin,k,kmax,Q,P,T,y,f,opt,u,fault)
!         CALL kmns(A,M,N,C,klim,K,Q,P,iter,U,fault)
!        CALL kmeans_MacQueen(A,mlim,m,n,C,kmax,k,Q,P,iter,U,fault)
        IF (fault>0) PRINT *, 'Error #', fault
        IF (k .NE. 3) PRINT *, 'Made ', k, ' clusters'
        

!      dump the output
       IF (dump) THEN
        OPEN (UNIT=2, FILE='wine.out', STATUS='NEW', 
     &         ACCESS='SEQUENTIAL', ERR=901)
       DO i = 1, M
          PRINT 52, Q(i)
           WRITE (2, 52) Q(i)
         DO j = 1, N        
           PRINT 51, A(i, j)
            WRITE (2, 51) A(i,j)
         END DO
        PRINT 53
         WRITE (UNIT=2, FMT=53)
       END DO
 51    FORMAT (F13.5, $)
 52    FORMAT (I3, $)
 53    FORMAT ()

        PRINT 53
       DO i = 1, K
         PRINT 52, i
          WRITE (2,52) i
         DO j = 1, N
          PRINT 51, C(i,j)
            WRITE (2, 51) C(i,j)
         END DO
         WRITE (UNIT=2, FMT=53)
        PRINT 53         
       END DO
       CLOSE (UNIT=2) 
      END IF

      ucalc = 0.0
      DO i = 1, m
        w = 0.0
        r = q(i)
        DO j = 1, n
          w = w + (C(r,j) - A(i,j)) **2
        END DO
        ucalc = ucalc + SQRT(w)
      END DO

      IF (MOD(o, 1) .EQ. 0) THEN        
        PRINT *, 'On try ', o, ' Distance was:  ', u, ' Calc U=', ucalc
      END IF
      
      best = MIN(best, ucalc)
      worst = MAX(worst, ucalc)
      total = total + ucalc
!      worst = MAX(worst, u)
!      total = total + u
      END DO ! next o
 
      PRINT *,'Worst case: ',worst,' best case: ',best,' Total: ',total

      GO TO 99
      
 901  STOP 'File i/o error'
 99   END 
